# Linkerd Steering Committee Charter

The goal of the Linkerd Steering Committee is to ensure that Linkerd meets the
needs of its current and future users. The Steering Committee represents the
voice of the user, and works with the Linkerd maintainers to help guide
development efforts towards solving concrete and immediate problems for Linkerd
adopters.

## Responsibilities

The Steering Committee’s responsibilities are to:

1. Provide feedback to project maintainers about Linkerd's featureset, UX, and
   operational model.
2. Assist Linkerd maintainers in prioritizing upcoming roadmap items and
   planned work.
3. Represent the "voice of the Linkerd user" both internally and to the broader
   community.
4. Provide neutral mediation for non-technical disputes.
5. Develop and maintain a project continuity plan.

## Membership

The Steering Committee comprises at most 7 people. To be eligible for
membership in the Steering Committee, you must:

1. Be responsible for a production Linkerd deployment of non-trivial size
2. Be willing and able to attend regularly-scheduled Steering Committee
   meetings
3. Abide by Linkerd's Code of Conduct.

Candidates for membership will be nominated by current Steering Committee
members or by Linkerd maintainers. If there are more nominations than Steering
Committee seats remaining, the same group shall vote on the candidates, and the
candidates with the most votes will become Steering Committee members. Any ties
will be broken by Linkerd maintainers.

Membership expires if any of the eligibility conditions is unmet, or after one
year. Members may seek reinstatement immediately in accordance with the rules
above.

## Meetings

Meetings will happen periodically not less than once a quarter. Recordings and
minutes will be posted publicly.

## Changes to this charter

Changes to this charter must be approved by a majority of Steering Committee
members and a majority of Linkerd maintainers.
