/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/linkerd/linkerd2/controller/gen/apis/policy/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeMeshTLSAuthentications implements MeshTLSAuthenticationInterface
type FakeMeshTLSAuthentications struct {
	Fake *FakePolicyV1alpha1
	ns   string
}

var meshtlsauthenticationsResource = v1alpha1.SchemeGroupVersion.WithResource("meshtlsauthentications")

var meshtlsauthenticationsKind = v1alpha1.SchemeGroupVersion.WithKind("MeshTLSAuthentication")

// Get takes name of the meshTLSAuthentication, and returns the corresponding meshTLSAuthentication object, and an error if there is any.
func (c *FakeMeshTLSAuthentications) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.MeshTLSAuthentication, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(meshtlsauthenticationsResource, c.ns, name), &v1alpha1.MeshTLSAuthentication{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.MeshTLSAuthentication), err
}

// List takes label and field selectors, and returns the list of MeshTLSAuthentications that match those selectors.
func (c *FakeMeshTLSAuthentications) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.MeshTLSAuthenticationList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(meshtlsauthenticationsResource, meshtlsauthenticationsKind, c.ns, opts), &v1alpha1.MeshTLSAuthenticationList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.MeshTLSAuthenticationList{ListMeta: obj.(*v1alpha1.MeshTLSAuthenticationList).ListMeta}
	for _, item := range obj.(*v1alpha1.MeshTLSAuthenticationList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested meshTLSAuthentications.
func (c *FakeMeshTLSAuthentications) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(meshtlsauthenticationsResource, c.ns, opts))

}

// Create takes the representation of a meshTLSAuthentication and creates it.  Returns the server's representation of the meshTLSAuthentication, and an error, if there is any.
func (c *FakeMeshTLSAuthentications) Create(ctx context.Context, meshTLSAuthentication *v1alpha1.MeshTLSAuthentication, opts v1.CreateOptions) (result *v1alpha1.MeshTLSAuthentication, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(meshtlsauthenticationsResource, c.ns, meshTLSAuthentication), &v1alpha1.MeshTLSAuthentication{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.MeshTLSAuthentication), err
}

// Update takes the representation of a meshTLSAuthentication and updates it. Returns the server's representation of the meshTLSAuthentication, and an error, if there is any.
func (c *FakeMeshTLSAuthentications) Update(ctx context.Context, meshTLSAuthentication *v1alpha1.MeshTLSAuthentication, opts v1.UpdateOptions) (result *v1alpha1.MeshTLSAuthentication, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(meshtlsauthenticationsResource, c.ns, meshTLSAuthentication), &v1alpha1.MeshTLSAuthentication{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.MeshTLSAuthentication), err
}

// Delete takes name of the meshTLSAuthentication and deletes it. Returns an error if one occurs.
func (c *FakeMeshTLSAuthentications) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(meshtlsauthenticationsResource, c.ns, name, opts), &v1alpha1.MeshTLSAuthentication{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeMeshTLSAuthentications) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(meshtlsauthenticationsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.MeshTLSAuthenticationList{})
	return err
}

// Patch applies the patch and returns the patched meshTLSAuthentication.
func (c *FakeMeshTLSAuthentications) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.MeshTLSAuthentication, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(meshtlsauthenticationsResource, c.ns, name, pt, data, subresources...), &v1alpha1.MeshTLSAuthentication{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.MeshTLSAuthentication), err
}
