/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "github.com/linkerd/linkerd2/controller/gen/apis/serverauthorization/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeServerAuthorizations implements ServerAuthorizationInterface
type FakeServerAuthorizations struct {
	Fake *FakeServerauthorizationV1beta1
	ns   string
}

var serverauthorizationsResource = v1beta1.SchemeGroupVersion.WithResource("serverauthorizations")

var serverauthorizationsKind = v1beta1.SchemeGroupVersion.WithKind("ServerAuthorization")

// Get takes name of the serverAuthorization, and returns the corresponding serverAuthorization object, and an error if there is any.
func (c *FakeServerAuthorizations) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.ServerAuthorization, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(serverauthorizationsResource, c.ns, name), &v1beta1.ServerAuthorization{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ServerAuthorization), err
}

// List takes label and field selectors, and returns the list of ServerAuthorizations that match those selectors.
func (c *FakeServerAuthorizations) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.ServerAuthorizationList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(serverauthorizationsResource, serverauthorizationsKind, c.ns, opts), &v1beta1.ServerAuthorizationList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.ServerAuthorizationList{ListMeta: obj.(*v1beta1.ServerAuthorizationList).ListMeta}
	for _, item := range obj.(*v1beta1.ServerAuthorizationList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested serverAuthorizations.
func (c *FakeServerAuthorizations) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(serverauthorizationsResource, c.ns, opts))

}

// Create takes the representation of a serverAuthorization and creates it.  Returns the server's representation of the serverAuthorization, and an error, if there is any.
func (c *FakeServerAuthorizations) Create(ctx context.Context, serverAuthorization *v1beta1.ServerAuthorization, opts v1.CreateOptions) (result *v1beta1.ServerAuthorization, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(serverauthorizationsResource, c.ns, serverAuthorization), &v1beta1.ServerAuthorization{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ServerAuthorization), err
}

// Update takes the representation of a serverAuthorization and updates it. Returns the server's representation of the serverAuthorization, and an error, if there is any.
func (c *FakeServerAuthorizations) Update(ctx context.Context, serverAuthorization *v1beta1.ServerAuthorization, opts v1.UpdateOptions) (result *v1beta1.ServerAuthorization, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(serverauthorizationsResource, c.ns, serverAuthorization), &v1beta1.ServerAuthorization{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ServerAuthorization), err
}

// Delete takes name of the serverAuthorization and deletes it. Returns an error if one occurs.
func (c *FakeServerAuthorizations) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(serverauthorizationsResource, c.ns, name, opts), &v1beta1.ServerAuthorization{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeServerAuthorizations) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(serverauthorizationsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.ServerAuthorizationList{})
	return err
}

// Patch applies the patch and returns the patched serverAuthorization.
func (c *FakeServerAuthorizations) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.ServerAuthorization, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(serverauthorizationsResource, c.ns, name, pt, data, subresources...), &v1beta1.ServerAuthorization{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ServerAuthorization), err
}
