# linkerd-multicluster-link

A helm chart containing the resources to enable mirroring
of services from a remote cluster.

Warning: The purpose of this chart is just to support the `linkerd
multicluster link` CLI command, which also produces the
`cluster-credentials` secret and the Link CR, which are not found in this
chart. Therefore this chart is not a replacement for that command, and
shouldn't be used as-is unless you really know what you're doing ;-)

![Version: 0.2.0](https://img.shields.io/badge/Version-0.2.0-informational?style=flat-square)

![AppVersion: edge-XX.X.X](https://img.shields.io/badge/AppVersion-edge--XX.X.X-informational?style=flat-square)

## Requirements

Kubernetes: `>=1.21.0-0`

| Repository | Name | Version |
|------------|------|---------|
| file://../../../charts/partials | partials | 0.1.0 |

## Values

| Key | Type | Default | Description |
|-----|------|---------|-------------|
| commonLabels | object | `{}` | Labels to apply to all resources |
| controllerImage | string | `"cr.l5d.io/linkerd/controller"` | Docker image for the Service mirror component (uses the Linkerd controller image) |
| controllerImageVersion | string | `"linkerdVersionValue"` | Tag for the Service Mirror container Docker image |
| enableHeadlessServices | bool | `false` | Toggle support for mirroring headless services |
| enablePSP | bool | `false` | Create RoleBindings to associate ServiceAccount of target cluster Service Mirror to the control plane PSP resource. This requires that `enabledPSP` is set to true on the extension and control plane install. Note PSP has been deprecated since k8s v1.21 |
| enablePodAntiAffinity | bool | `false` | Enables Pod Anti Affinity logic to balance the placement of replicas across hosts and zones for High Availability. Enable this only when you have multiple replicas of components. |
| gateway.probe.port | int | `4191` | The port used for liveliness probing |
| logFormat | string | `"plain"` | Log format (`plain` or `json`) |
| logLevel | string | `"info"` | Log level for the Multicluster components |
| nodeSelector | object | `{}` | Node selectors for the Service mirror pod |
| podAnnotations | object | `{}` | Additional annotations to add to all pods |
| podLabels | object | `{}` | Additional labels to add to all pods |
| replicas | int | `1` | Number of service mirror replicas to run |
| resources | object | `{}` | Resources for the Service mirror container |
| serviceMirrorRetryLimit | int | `3` | Number of times update from the remote cluster is allowed to be requeued (retried) |
| serviceMirrorUID | int | `2103` | User id under which the Service Mirror shall be ran |
| targetClusterName | string | `""` | Name of the target cluster that's going to be linked |
| tolerations | object | `{}` | Tolerations for the Service mirror pod |

----------------------------------------------
Autogenerated from chart metadata using [helm-docs v1.11.0](https://github.com/norwoodj/helm-docs/releases/v1.11.0)
